> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Update a specific segment.

PUT https://prod-api.raisedonors.com/api/Segment/{id}
Content-Type: application/json

Reference: https://virtuous.ferndocs.com/reference/raise/segment/updatesegment

## Authentication

- `Authorization` header (required) — JWT Authorization header using the Bearer scheme. Example: "Authorization: Bearer \{token}"

## Request

### Path parameters

- `id` (long, required) — The ID of the segment.

### Body (application/json)

This endpoint expects a SegmentRequest.

- `campaignId` (long, required)
- `name` (string, required)
- `code` (string, required)
- `description` (string, optional, nullable)
- `externalIdentifier` (string, optional, nullable)

## Response

### 200

OK

- `id` (long, optional) — Gets or sets the identifier.
- `campaignId` (long, optional) — Gets or sets the campaign identifier.
- `campaignName` (string, optional, nullable) — Gets or sets the campaign name.
- `name` (string, optional, nullable) — Gets or sets the name.
- `description` (string, optional, nullable) — Gets or sets the description.
- `code` (string, optional, nullable) — Gets or sets the code.
- `externalIdentifier` (string, optional, nullable) — Gets or sets the external identifier.
- `totalDonors` (integer, optional) — Gets or sets the total donors.
- `totalGifts` (integer, optional) — Gets or sets the total gifts.
- `totalGiftAmount` (string, optional, nullable) — Gets or sets the total gift amount.
- `averageGiftAmount` (string, optional, nullable) — Gets or sets the average gift amount.
- `medianGiftAmount` (string, optional, nullable) — Gets or sets the median gift amount.
- `highestGiftAmount` (string, optional, nullable) — Gets or sets the highest gift amount.
- `totalVisitors` (integer, optional) — Gets or sets the total visitors.
- `conversionRate` (string, optional, nullable) — Gets or sets the conversion rate.
- `createdDateTime` (string, optional, nullable) — Gets or sets the created date time.
- `modifiedDateTime` (string, optional, nullable) — Gets or sets the modified date time.

## Errors

### 400 Bad Request Error

Bad Request

- `Segment_UpdateSegmentRequestBadRequestError`
  - ProblemDetails: ProblemDetails
  - HttpValidationProblemDetails: HttpValidationProblemDetails

## Types

### ProblemDetails

- `type` (string, optional, nullable)
- `title` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `detail` (string, optional, nullable)
- `instance` (string, optional, nullable)

### HttpValidationProblemDetails

- `detail` (string, optional, nullable)
- `errors` (map from string to list of string, optional, nullable)
- `instance` (string, optional, nullable)
- `status` (integer, optional, nullable)
- `title` (string, optional, nullable)
- `type` (string, optional, nullable)

## Examples

**Request**

```json
{
  "campaignId": 1024,
  "name": "Spring Fundraising Segment",
  "code": "SPRING2024"
}
```

**Response**

```json
{
  "id": 1,
  "campaignId": 1024,
  "campaignName": "2024 Spring Campaign",
  "name": "Spring Fundraising Segment",
  "description": "Segment targeting donors active in spring 2024 campaign",
  "code": "SPRING2024",
  "externalIdentifier": "SEG-2024-SPRING",
  "totalDonors": 350,
  "totalGifts": 420,
  "totalGiftAmount": "12500.00",
  "averageGiftAmount": "29.76",
  "medianGiftAmount": "25.00",
  "highestGiftAmount": "500.00",
  "totalVisitors": 1200,
  "conversionRate": "29.17%",
  "createdDateTime": "2024-01-15T09:30:00Z",
  "modifiedDateTime": "2024-04-10T16:45:00Z"
}
```

**SDK Code**

```python
import requests

url = "https://prod-api.raisedonors.com/api/Segment/1"

payload = {
    "campaignId": 1024,
    "name": "Spring Fundraising Segment",
    "code": "SPRING2024"
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://prod-api.raisedonors.com/api/Segment/1';
const options = {
  method: 'PUT',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"campaignId":1024,"name":"Spring Fundraising Segment","code":"SPRING2024"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://prod-api.raisedonors.com/api/Segment/1"

	payload := strings.NewReader("{\n  \"campaignId\": 1024,\n  \"name\": \"Spring Fundraising Segment\",\n  \"code\": \"SPRING2024\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://prod-api.raisedonors.com/api/Segment/1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"campaignId\": 1024,\n  \"name\": \"Spring Fundraising Segment\",\n  \"code\": \"SPRING2024\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://prod-api.raisedonors.com/api/Segment/1")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"campaignId\": 1024,\n  \"name\": \"Spring Fundraising Segment\",\n  \"code\": \"SPRING2024\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://prod-api.raisedonors.com/api/Segment/1', [
  'body' => '{
  "campaignId": 1024,
  "name": "Spring Fundraising Segment",
  "code": "SPRING2024"
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://prod-api.raisedonors.com/api/Segment/1");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"campaignId\": 1024,\n  \"name\": \"Spring Fundraising Segment\",\n  \"code\": \"SPRING2024\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "campaignId": 1024,
  "name": "Spring Fundraising Segment",
  "code": "SPRING2024"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://prod-api.raisedonors.com/api/Segment/1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```